//Author; George Koutsogiannakis
//Spring 2011
//Copyright reserved. No usage is allowed without the author's approval.

package practicePrograms;
import java.awt.Graphics;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
public class PracticeProgram1 extends JFrame
{	

	//Global variables needed
	Container c;
	JTextField jtf1;
	JTextField jtf2;
	JTextField jtf3;
	JButton  jb1;
	JButton jb2;

	JTextArea ta;
	ArrayList<String> al=new ArrayList<String>();

	public static void main(String[] args) 
	{
		PracticeProgram1 pr1=new PracticeProgram1();
		pr1.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	public PracticeProgram1()
	{
		super("JFrame for Practice Program 1");
		buildGUI();
	}

	public void buildGUI()
	{
		
		//Get hold of an object for the content pane --container
		c=getContentPane();

		//First let us construct the menu

		JMenuBar bar=new JMenuBar();
		
		JMenu menu=new JMenu("File");
		JMenuItem saveas=new JMenuItem("Save As");
		JMenuItem read=new JMenuItem("Read");
		JMenuItem exit=new JMenuItem("Exit");
		menu.add(saveas); 
		menu.add(read);
		menu.add(exit);
		bar.add(menu);
		
		bar.setPreferredSize(new Dimension(300, 50)); 
		
		setJMenuBar(bar);
		//The menu is ready but the  events attached to the menu items need to be programmed.

		// In order to be able to see the JFrame at this point in time, let us make it visble 
		//before we proceed with other code. It is advisable to compile and run our program to see how
		// much we have accompished periodically. You can mak eit visible with the next two lines of code
		//but you would have to comment tehm out and place them at the end of teh GUI construction when done.
		//in order to be able to see the rest of the GUI.
		//setSize(1000, 700);    
		//setVisible(true);
		//At this point if you compile and run the program, you should be able to see the JFrame on teh screen.

		//Set BLM to be the layout manager for the content pane.
		c.setLayout(new BorderLayout(5,5));
		
		//Let complete the rest of the GUI before we create the cod efor the menu events and teh other events.
		//We are going to add two JPanel components to teh JFrame. One on teh North side 
		//and the other on the South side.
		//We keep each JPanel as a separate inner class within this outer class. Our task in this outer class becomes
		//as simple as adding the two panels objects one North and the other South

		PanelNorth pn=new PanelNorth();
		PanelSouth ps=new PanelSouth();
		c.add(pn, BorderLayout.NORTH);
		c.add(ps, BorderLayout.SOUTH);

		//NOW THAT WE ARE DONE WITH THE FRAME, LET US REGISTER THE COMPONENTS THAT CREATE ACTION WITH THEIR EVENT HANDLERS
		TextFieldHandler th=new TextFieldHandler();
		jb1.addActionListener(th);

		TextAreaHandler tah=new TextAreaHandler();
		jb2.addActionListener(tah);
		SaveAsHandler sah=new SaveAsHandler();
		saveas.addActionListener(sah);
		ReadHandler rh=new ReadHandler();
		read.addActionListener(rh);

		Exit e=new Exit();
		exit.addActionListener(e);
		
		//FINALLY MAKE THE FRAME VISIBLE.
		setSize(1000, 700);    
		setVisible(true);
	}
	
	//THIS CLASS HANDLES THE GRAPHICS FOR THE FIRST PANEL TO BE PLACED NORTH
	class PanelNorth extends JPanel
	{
		public PanelNorth()
		{
			//each panel will prepare itself by setting its own components
			//Horintal boxes will box teh labels with the text fields.
		   //Finally, let us prepare a Vertical Box to box all horizontal box components tightly
			Box box=Box.createVerticalBox();  
			Box boxh1=Box.createHorizontalBox();
			JLabel namelabel= new JLabel ("Enter your name", JLabel.LEFT);
			jtf1=new JTextField("Enter your full name here and press Enter", 35);
			
			boxh1.add(namelabel);
			Component empty=boxh1.createHorizontalStrut(65);
			boxh1.add(empty);
			boxh1.add(jtf1);

			Box boxh2=Box.createHorizontalBox();
			JLabel addresslabel= new JLabel ("Enter your address", JLabel.LEFT);
			jtf2=new JTextField("Enter your address here and press Enter", 35);
			boxh2.add(addresslabel);
			Component empty1=boxh2.createHorizontalStrut(50);
			boxh2.add(empty1);
			boxh2.add(jtf2);

			Box boxh3=Box.createHorizontalBox();
			JLabel agelabel= new JLabel ("Enter your age", JLabel.LEFT);
			jtf3=new JTextField("Enter your age here and press Enter", 35);
			boxh3.add(agelabel);
			Component empty2=boxh3.createHorizontalStrut(75);
			boxh3.add(empty2);
			boxh3.add(jtf3);
			
			Component emp=box.createVerticalStrut(50);
			box.add(emp);
			box.add(boxh1);
			Component emptyv=box.createVerticalStrut(35);
			box.add(emptyv);
			box.add(boxh2);
			Component emptyv1=box.createVerticalStrut(35);
			box.add(emptyv1);
			box.add(boxh3);
			Box boxagain=Box.createVerticalBox();

			jb1=new JButton("Submit");

			boxagain.add(box);
			Component emptyv2=boxagain.createVerticalStrut(35);
			boxagain.add(emptyv2);
			boxagain.add(jb1);
			add(boxagain);
		}
	
	
	}

	//THIS CLASS HANDLES THE GRAPHICS FOR THE SECOND PANEL TO BE PLACED SOUTH
	
	class PanelSouth extends JPanel
	{
	
		public PanelSouth()
		{
			
			ta= new JTextArea(10,30);
			JScrollPane textscrollpane= new JScrollPane (ta);
		
			jb2=new JButton("Display");
			
			Box v=Box.createVerticalBox();
			Component empty3=v.createVerticalStrut(50);
			v.add(textscrollpane);
			v.add(empty3);
			Component e=v.createHorizontalStrut(30);
			Box h=Box.createHorizontalBox();
			h.add(e);
			h.add(jb2);
			v.add(h);
			Component empty4=v.createVerticalStrut(50);
			v.add(empty4);
			add(v);



		}
	
		
	}

	//PROCEED WITH THE EVENTS HANDLING CLASSES NOW (INNER CLASSES)

	 class TextFieldHandler implements ActionListener
	{
		public void actionPerformed (ActionEvent event)
		{
			System.out.println("submit buttton activated");
			if (event.getSource()== jb1)
			{
				
				String name=jtf1.getText();
				al.add(name);
				
				String address=jtf2.getText();
				al.add(address);
				
				String age=jtf3.getText();
				al.add(age);
			}
			
		}

	}

	class TextAreaHandler implements ActionListener
	{
		public void actionPerformed (ActionEvent event)
		{
			System.out.println("display buttton activated");
			if (event.getSource()== jb2)
			{   
			    //first clear the existing display
				ta.setText(" ");
				for(int i=0; i<=al.size()-1; i++)
				{
					ta.append("\n");
					ta.append(al.get(i));
					
				}

			}
			
		}
		
	}

	class SaveAsHandler implements ActionListener
	{

		public void actionPerformed (ActionEvent event)
		{
	
				JFileChooser filechooser = new JFileChooser ();
				filechooser.setFileSelectionMode ( JFileChooser.FILES_ONLY);

				int result = filechooser.showSaveDialog (null);
				if (result== JFileChooser.CANCEL_OPTION)
					
				{
					return;
				}
				File filename = filechooser.getSelectedFile();
				if (filename==null||filename.getName().equals (" "))
				{
					JOptionPane.showMessageDialog( null, "Invalid File Name", "Invalid FileName", JOptionPane.ERROR_MESSAGE );
				}
				else 
				{
					  try
					  {
							System.out.println("I am ready to create the streams in MenuHandler");
						
							FileOutputStream file = new FileOutputStream(filename);
						
							OutputStreamWriter filestream = new OutputStreamWriter(new BufferedOutputStream(file));
							for(int f=0; f<=al.size()-1; f++)
							{
									filestream.write(al.get(f));
							}
							filestream.flush();
							file.close();
						System.out.println("I closed the streams in MenuHandler");
					 }
					  catch ( IOException ioException )
					  {
							JOptionPane.showMessageDialog (null, "File Does not exist", "Invalid File Name", JOptionPane.ERROR_MESSAGE);
					   }
				}
		
		}

	}

	class ReadHandler implements ActionListener
	{
	
	
		public void actionPerformed (ActionEvent event)
		{
			
				JFileChooser filechooser = new JFileChooser ();
				filechooser.setFileSelectionMode ( JFileChooser.FILES_ONLY);
				int result = filechooser.showSaveDialog (null);
				if (result== JFileChooser.CANCEL_OPTION)
					
				{
					return;
				}
				File filename = filechooser.getSelectedFile();
				if (filename==null||filename.getName().equals (" "))
				{
					JOptionPane.showMessageDialog( null, "Invalid File Name", "Invalid FileName", JOptionPane.ERROR_MESSAGE );
				}
				else 
				{
					char[] chararray=new char[1000];
					try
					  {
						
						  System.out.println("I am ready to create the streams in MenuHandler");
						
						  FileInputStream file = new FileInputStream(filename);
						
						  InputStreamReader filestream = new InputStreamReader(new BufferedInputStream(file));	
						  int x=filestream.read(chararray);
						  while(x!=-1)
						  {
							x=filestream.read(chararray);
						  }
						   
						  String str=new String(chararray);
						  ta.setText(str);
						  ta.append("\n");
						  filestream.close();
						  System.out.println(str);

					 }
					 catch ( IOException ioException )
					{
							JOptionPane.showMessageDialog (null, "File Does not exist", "Invalid File Name", JOptionPane.ERROR_MESSAGE);
					}
				}
		}
	}

	public class Exit implements ActionListener
	{

		public void actionPerformed(ActionEvent ae)
		{
			System.exit(0);
		}

	}
}
